# SiEPIC Test Creator

[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)
[![codecov](https://codecov.io/gh/SiEPIC/SiEPIC_testcreator/graph/badge.svg?token=8gQqPJ2Vfx)](https://codecov.io/gh/SiEPIC/SiEPIC_testcreator)

A tool for creating YAML files for use across UBC probe stations. This aplication features a UI that allows students and users to link on chip devices to custom test sequences.

## Setup

1. **Prerequisites/Labelling:** Python 3.10 and above
![](readme_images/optical_labels.png)
![](readme_images/electrical_labels.png)
  
2. **Installation**

![](readme_images/installation.png)

## Usage

Find here instruction on the work flow of the application

The GUI can be launched using the terminal or via python. For an example using python, see [run_gui.py](example/run_gui.py). To launch the GUI via the terminal, execute the command below:
```
siepic_testcreator --gui
```


![](readme_images/example_load.png)
![](readme_images/extractcoordlabels.png)

![](readme_images/upload_file.png)
![](readme_images/create_sequences.png)
![](readme_images/general_design.png)

![](readme_images/time_limit.png)
![](readme_images/seting_routines.png)


## License

This project is licensed under the MIT License - see the [LICENSE.md](LICENSE.md) file for details.
